#!/usr/bin/python
# -*- coding: utf-8 -*-
import sys
import os
import time
import pickle
from numpy import *
from collections import defaultdict
from collections import OrderedDict
from pycompss.api.task import task
from pycompss.api.parameter import *

nodes = 32
numbers =   640000
num_range = 2000
#num_range = 100


#quiza priority ayuda cuando se ejecute en grande
@task(returns = dict)
def calculate_range(block, nodes, num_range, idx):
	step = num_range / nodes
	idx2 = 0
	partial_result = {}
	for num in block:
		initial = 0
		final = step
		entra = False
		while initial < num_range:
			if num >= initial and num < final:
				partial_result[initial, idx, idx2] = num
				entra = True
			initial = initial + step
			final = final + step
		idx2 = idx2 + 1
		print (entra, num)
	return partial_result

@task(returns=set)
def reduce(result):
	return set().union(*result)

def sorting(partialResult, result,nodes,num_range):
	new_Dict = minimize_dict(partialResult)
	step = num_range / nodes
	sorted_new_Dict = OrderedDict()
	sorted_new_Dict = OrderedDict(sorted(new_Dict.iteritems(),key=lambda (k,v): k,reverse=False))
	initial = 0
	final = step
	idx = 0
	sizes = []
	while initial < num_range:
		start_pos = 0
		for k,v in sorted_new_Dict.iteritems():
			sizes.append(start_pos)
			start_pos = start_pos + len(v)
		position = 0
		for k,v in sorted_new_Dict.iteritems():
			#v = compss_wait_on(v)
			if int(k) >= initial and int(k) < final:
				result.append(sort_in_worker(k, v, sizes[position]))
				initial = initial + step
				final = final + step
			position = position + 1
	
	for i in range(len(result)):
		result[i] = compss_wait_on(result[i])
	
	sort = reduce(result)
	sort = compss_wait_on(sort)
	return sort

@task(returns = dict)
def sort_in_worker(range_initial, block, position):
    #print type(block)
    local_block = sorted(block)
    result = {}
    idx = 0
    for num in local_block:
        curr_pos = position + idx
        result[curr_pos] = num
	idx = idx + 1
    return result


def minimize_dict(partialResult):
    new_Dict = defaultdict(list)
    for key, value in partialResult.items():
        value = compss_wait_on(value)
        for val in value:
            new_Dict[val[0]].append(value[val])
    return new_Dict

if __name__ == "__main__":
	from pycompss.api.api import compss_wait_on
	
	numbers = int(sys.argv[1])
	nodes = int(sys.argv[2])
	num_range = int(sys.argv[3])

	

	'''Generate random numbers'''
	#nums = random.random_integers(num_range,size=(numbers,))

	'''read numbers from pickle file'''
	#numsFile = sys.argv[4]
	#f = open(numsFile,'r')
	#nums = pickle.load(f)
	#print (nums, len(nums))

	'''read numbers from file'''
	
	numsFile = sys.argv[4]
	f = open(numsFile,'r')
	
	nums = []
	for line in f:
		nums = asarray([int(x) for x in line.strip().split(" ")])
	
	print (nums, len(nums))
	print type(nums)
	numbers = len(nums)

	if numbers/nodes < num_range:
		print 'error'
		num_range = int(numbers/nodes)
		print ("using numrange= ",num_range)
	
	partialResult = {}
	result = []
	start = time.time()

	nums_per_node = numbers/nodes
	keys = [nums[i*nums_per_node:i*nums_per_node+nums_per_node] for i in range(nodes)]

	idx = 0
	for k in keys:
		partialResult[idx] = calculate_range(k,nodes,num_range,idx)
		idx = idx + 1

	sortedNums = sorting(partialResult,result,nodes,num_range)

	#sortedNums = set().union(*result)
	print type(sortedNums)
	print sortedNums

	end = time.time()
	print "Ellapsed time(s)" 
	print end - start

	#print result
	'''
	aux = list(sortedNums.items())
	ff = open('./result.txt','w')
	pickle.dump(aux,ff)
	ff.close()
	'''
	'''Open result file'''
	#f = open('./result.txt','r')
	#aux = pickle.load(f)
	#print(aux)